using namespace std;

#define long_proc typedef long (__stdcall *zProc)
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16)) 

long dpi(IN long nPix) {
    static float ratio;
    if (ratio == 0) {
        HDC hDC = GetDC(NULL); 
        ratio = (GetDeviceCaps(hDC, LOGPIXELSX) / 96.0f);
        ReleaseDC(NULL, hDC);
    }
    return (long) (nPix * ratio);
}

long CheckStyle(IN long nMainStyle, IN long nStyleToCheck) {
    long nRet = 0;
    if ((nMainStyle & nStyleToCheck) == nStyleToCheck) { nRet = -1; }
    return nRet;
}

WCHAR* STRL(IN long N) {
    static WCHAR longstr[33] = {0};
    _ltow_s(N, longstr, 10);
    return (WCHAR*)longstr;
}

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

WCHAR* EXEpath() {
    static WCHAR zPath[MAX_PATH] = { 0 };
    if (wcslen(zPath) == 0) {
        if (GetModuleFileName(0, zPath, sizeof(zPath))) {
            long nLen = (long)wcslen(zPath);
            long nPos = nLen;
            for (long K = 1; K <= nLen; K++) {
                if (_wcsicmp(&zPath[nPos - K], L"\\") != 0) {
                    zPath[nPos - K] = NULL;
                } else { 
                    break;
                }
            }
        }
    }
    return zPath;
}

WCHAR* EXEresource() {
    static WCHAR zResource[MAX_PATH] = { 0 };
    if (wcslen(zResource) == 0) { PathCombine(zResource, EXEpath(), L"Resource\\"); }
    return zResource;
}

long IsFileImage(IN WCHAR* zFileName) {
    long nRet = 0;
    WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
    if (zFileName) {
        _wsplitpath_s(zFileName, drive, dir, fname, ext);
        if (wcslen(ext)) {
            wcsncat_s(ext, L".", 1);
            CharLower(ext);
            if (wcsstr(L".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", ext)) { nRet = -1; }
        }
    }
    return nRet;
}

LRESULT List_Add(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hList) {
       if (wcslen(zTmp)) { nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp); }
    }
    return nIndex;
}

void List_DeleteAll(IN HWND hList) {
    if (hList) { SendMessage(hList, LB_RESETCONTENT, 0, 0); }
}

long List_FindString(IN HWND hList, IN WCHAR* zTmp) {
    long nIndex = 0;
    if (IsWindow(hList)) {
        nIndex = (long) SendMessage(hList, LB_FINDSTRING, -1, (LPARAM) zTmp);
        if (nIndex > -1) { ++nIndex; }
    }
    return nIndex;
}

long List_GetCount(IN HWND hList) {
    long nRet = 0;
    if (IsWindow(hList)) { nRet = (long) SendMessage(hList, LB_GETCOUNT, 0, 0); }
    return nRet;
}

long List_GetCursel(IN HWND hList) {
    long nIndex = 0;
    if (hList) {
       nIndex = (long) SendMessage(hList, LB_GETCURSEL, 0, 0);
       if (nIndex > -1) { ++nIndex; } // Because ListBox is zero based
    }
    return nIndex;
}

WCHAR* List_GetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    memset(szData, 0, sizeof(WCHAR));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

void List_SelectPlus(IN HWND hList, IN long nIndex) {
    if (nIndex < 0) { hList = 0; }
    if (hList) {
        if (nIndex > 0) { --nIndex; } // Because ListBox is zero based
        SendMessage(hList, LB_SETCURSEL, nIndex, 0); 
    }
}
